#include <stdio.h>
#include <string.h> 
#include <stdlib.h>
#include <assert.h>

#include "gen.h"
#include "dictionnaire.h"

FILE* fd;
FILE* ft;

static int id_data=0;

static int id_boucle=0;

static int offset=0;
static int offset_tmp=0;

static Boucle* CurBoucle=NULL;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Version 08/11/2007
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////
// Pile des boucles
////////////////////////////////////////////////////////

void BoucleAddEntry(void)
{
    Boucle *newelem = malloc(sizeof(Boucle));

    newelem->id=id_boucle++;

    newelem->next=CurBoucle;

	CurBoucle=newelem;
}

void BoucleCleanEntry()
{
	Boucle* tmp = CurBoucle;
    	CurBoucle=CurBoucle->next;
	free (tmp);
}


////////////////////////////////////////////////////////
// Creation de fichier
////////////////////////////////////////////////////////

void CreateFileData(unsigned char * name)
{
	fd=fopen((char *)name,"w");
	fseek(fd,0,SEEK_SET);
	fprintf(fd,".data\n");
}

void CloseFileData(void)
{
	fclose(fd);
}

void CreateFileText(unsigned char * name)
{
	ft=fopen((char *)name,"w");
	fseek(ft,0,SEEK_SET);
	fprintf(ft,".text\n");
	fprintf(ft,"   .globl main\n");
	fprintf(ft,"main:\n");
	fprintf(ft,"addiu $sp, $sp, -4\n");
	fprintf(ft,"sw $ra, 0($sp)\n");

	fprintf(ft,"move $fp, $sp\n");
	fprintf(ft,"move $s0, $sp\n");
}

void CloseFileText(void)
{
	fprintf(ft,"addiu $sp, $sp, 4\n");
	fprintf(ft,"lw $ra, -4($sp)\n");
	fprintf(ft,"jr $ra\n");
	fclose(ft);
}

////////////////////////////////////////////////////////
// Ecriture dans la zone de donnees globales
////////////////////////////////////////////////////////

void AddStaticIntData(char * name)
{
    int id;

	dicSelect(name);
	id=dicGetId();
	fprintf(fd,"%s_%d: .word 0\n", name, id);    
}

void AddStaticFloatData(char * name)
{
    int id;

	dicSelect(name);
	id=dicGetId();
	fprintf(fd,"%s_%d: .word 0\n", name, id);    
}


void AddStaticBoolData(char * name)
{
    int id;

	dicSelect(name);
	id=dicGetId();
	fprintf(fd,"%s_%d: .word 0\n", name, id);
}

void AddStaticArrayData(char * name)
{
	int id;
	int i;
	Bornes* bornes;

	dicSelect(name);
	id=dicGetId();
	fprintf(fd,"%s_%d:", name, id);

	fprintf(fd," .word %d\n",bornes->BorneInf);
	//bornes
	fprintf(fd," .word %d\n",bornes->BorneInf);
	fprintf(fd," .word %d\n",bornes->BorneSup);
	
	bornes=dicGetArray();
	for(i=bornes->BorneInf ; i<bornes->BorneSup ; i++)
		fprintf(fd," .word 0\n");
}

////////////////////////////////////////////////////////
// Affichage
////////////////////////////////////////////////////////

void DisplayString(char* string)
{
	fprintf(ft,"  #DisplayString_\n");
	
	fprintf(fd,"string_%d:\n",id_data);
	fprintf(fd," .asciiz %s\n",string);
	
	fprintf(ft,"   la $a0, string_%d\n", id_data);
	fprintf(ft,"   li $v0, 4\n");
	fprintf(ft,"   syscall\n");
	
	id_data++;
}

void DisplayVarInt(char* name)
{
	fprintf(ft,"  #DisplayVarInt_%s\n",name);

	//var dans le contexte local
	if(dicSelect(name))
	{
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   lw $a0, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   lw $a0, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 1\n");
    fprintf(ft,"   syscall\n");
	}
	//global
	else
	{
		//on sauve $fp 
		fprintf(ft,"   sw $fp, -4($sp)\n");
		//on recupere le $fp global (@ debut code, dans $s0)
		fprintf(ft,"   move $fp, $s0\n");
		
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   lw $a0, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   lw $a0, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 1\n");
    fprintf(ft,"   syscall\n");
		
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
	}
}

void DisplayVarBool(char* name)
{
	fprintf(ft,"  #DisplayVarBool_%s\n",name);

	//var dans le contexte local
	if(dicSelect(name))
	{
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   lw $a0, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   lw $a0, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 1\n");
    fprintf(ft,"   syscall\n");
	}
	//global
	else
	{
		//on sauve $fp 
		fprintf(ft,"   sw $fp, -4($sp)\n");
		//on recupere le $fp global (@ debut code, dans $s0)
		fprintf(ft,"   move $fp, $s0\n");
		
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   lw $a0, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   lw $a0, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 1\n");
    fprintf(ft,"   syscall\n");
		
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
	}
}

void DisplayVarFloat(char* name)
{
	fprintf(ft,"  #DisplayVarFloat_%s\n",name);

	//var dans le contexte local
	if(dicSelect(name))
	{
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   l.s $f12, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   l.s $f12, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 2\n");
    fprintf(ft,"   syscall\n");
	}
	//global
	else
	{
		//on sauve $fp 
		fprintf(ft,"   sw $fp, -4($sp)\n");
		//on recupere le $fp global (@ debut code, dans $s0)
		fprintf(ft,"   move $fp, $s0\n");
		
    if(dicGetOffset() != -1)
    {
      fprintf(ft,"   l.s $f12, %d($fp)\n", dicGetOffset());
    }
    else
    {
      fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
			fprintf(ft,"   l.s $f12, 0($t1)\n");
    }
    fprintf(ft,"   li $v0, 2\n");
    fprintf(ft,"   syscall\n");
		
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
	}	
}

void DisplayInt(int val)
{
	fprintf(ft,"  #DisplayInt_%d\n",val);
	
	fprintf(ft,"   li $a0, %d\n",val);
	fprintf(ft,"   li $v0, 1\n");
	fprintf(ft,"   syscall\n");
}

void DisplayBool(int val)
{
	fprintf(ft,"  #DisplayBool_%d\n",val);
	
	fprintf(ft,"   li $a0, %d\n",val);
	fprintf(ft,"   li $v0, 1\n");
	fprintf(ft,"   syscall\n");
}

void DisplayFloat(float val)
{
	fprintf(ft,"  #DisplayFloat_%f\n",val);
	
	fprintf(ft,"   li.s $f12, %f\n",val);
	fprintf(ft,"   li $v0, 2\n");
	fprintf(ft,"   syscall\n");
}

void DisplayStackHead(SYMType type)
{
	assert(type != SYM_VOID);
  switch(type)
  {
    case SYM_BOOLEAN:
    case SYM_INTEGER:
      fprintf(ft,"  #DisplayStackHead_BOOL_INT\n");
      fprintf(ft,"   lw $a0, 0($sp)\n");
      fprintf(ft,"   li $v0, 1\n");
      break;
    case SYM_REAL:
      fprintf(ft,"  #DisplayStackHead_REAL\n");
      fprintf(ft,"   l.s $f12, 0($sp)\n");
      fprintf(ft,"   li $v0, 2\n");
      break;
  }

	fprintf(ft,"   syscall\n");
}

////////////////////////////////////////////////////////
// Saisie Clavier
////////////////////////////////////////////////////////

void ReadString(void)
{
	fprintf(ft,"  #ReadString\n");
	
	fprintf(ft,"   li $v0, 8\n"); // 8 -> Pour lire une chaine de caracteres au clavier
	fprintf(ft,"   addiu $sp, $sp, -%d\n",SIZE_STR); // Reservation de place sur la pile pour la chaine de caracteres
	fprintf(ft,"   move $a0, $sp\n"); // Adresse du debut de la chaine
	fprintf(ft,"   li $a1, %d\n",SIZE_STR); // Taille de la chaine
	fprintf(ft,"   syscall\n"); // Appel systeme pour la saisie clavier
}


////////////////////////////////////////////////////////
// Comparaisons
////////////////////////////////////////////////////////

// $t1 < $t0  ;  2em pile < sommet pile
void LessThan(void)
{
	fprintf(ft,"  #LessThan\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   slt $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// $t1 <= $t0  ;  2em pile <= sommet pile
void LessThanEqual(void)
{
	fprintf(ft,"  #LessThanEqual\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   sle $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// $t1 > $t0  ;  2em pile > sommet pile
void GreaterThan(void)
{
	fprintf(ft,"  #GreaterThan\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   sgt $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// $t1 >= $t0  ;  2em pile >= sommet pile
void GreaterThanEqual(void)
{
	fprintf(ft,"  #GreaterThanEqual\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   sge $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// $t1 = $t0  ;  2em pile = sommet pile
void Equal(void)
{
	fprintf(ft,"  #Equal\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   seq $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// $t1 != $t0  ;  2em pile != sommet pileCreateBlock()
void NotEqual(void)
{
	fprintf(ft,"  #NotEqual\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   sne $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

////////////////////////////////////////////////////////
// Conversions
////////////////////////////////////////////////////////

// converti le sommet de pile (variable courante) int en float
void IntToFloat(void)
{
	fprintf(ft,"  #IntToFloat\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   cvt.s.w $f1, $f0\n");
	fprintf(ft,"   s.s $f1, 0($sp)\n");
}

// converti le sommet de pile (variable courante) float en int
void FloatToInt(void)
{
	fprintf(ft,"  #FloatToInt\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   cvt.w.s $f1, $f0\n");
	fprintf(ft,"   s.s $f1, 0($sp)\n");
}

// converti le second de pile float en int
void IntToFloatSecond(void)
{
	fprintf(ft,"  #IntToFloatSecond\n");
	
	fprintf(ft,"   l.s $f0, 4($sp)\n");
	fprintf(ft,"   cvt.s.w $f1, $f0\n");
	fprintf(ft,"   s.s $f1, 4($sp)\n");
}

// converti le second de pile float en int
void FloatToIntSecond(void)
{
	fprintf(ft,"  #FloatToIntSecond\n");
	
	fprintf(ft,"   l.s $f0, 4($sp)\n");
	fprintf(ft,"   cvt.w.s $f1, $f0\n");
	fprintf(ft,"   s.s $f1, 4($sp)\n");
}

////////////////////////////////////////////////////////
// Operations logiques
////////////////////////////////////////////////////////

// negation logique du sommet de pile (variable courante)
void Not(void)
{
  fprintf(ft,"  #Not\n");
  fprintf(ft,"   lw $t0, 0($sp)\n");
  fprintf(ft,"   li $t1, 1\n");
  fprintf(ft,"   sltu $t2, $t0, $t1\n");
  fprintf(ft,"   sw $t2, 0($sp)\n");
}

// et logique des 2 variables en sommet de pile
void And(void)
{
	fprintf(ft,"  #And\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   and $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// ou logique des 2 variables en sommet de pile
void Or(void)
{
	fprintf(ft,"  #Or\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   or $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

////////////////////////////////////////////////////////
// Operations arithmetiques
////////////////////////////////////////////////////////

//change le sommet de pile int en son oppose
void NegInt()
{
  	fprintf(ft,"  #NegInt\n");
  
  	fprintf(ft,"   lw $t0, 0($sp)\n");
  	fprintf(ft,"   neg $t1, $t0\n");
  	fprintf(ft,"   sw $t1, 0($sp)\n");
}

// addition des 2 variables int en sommet de pile
void AddInt(void)
{
	fprintf(ft,"  #AddInt\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   add $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// soustraction des 2 variables int en sommet de pile
// $t1 - $t0  ;  2em pile - sommet pile
void SubInt(void)
{
	fprintf(ft,"  #SubInt\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   sub $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// multiplication des 2 variables int en sommet de pile
void MulInt(void)
{
	fprintf(ft,"  #MulInt\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   mul $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// division des 2 variables int en sommet de pile
// $t1 / $t0  ;  2em pile /0 sommet pile
void DivInt(void)
{
	fprintf(ft,"  #DivInt\n");
	
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   lw $t1, 4($sp)\n");
	fprintf(ft,"   div $t2, $t1, $t0\n");
	fprintf(ft,"   sw $t2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}


////////////////////////////////////////////////////////

//change le sommet de pile int en son oppose
void NegFloat()
{
  	fprintf(ft,"  #NegInt\n");
  
  	fprintf(ft,"   l.s $f0, 0($sp)\n");
  	fprintf(ft,"   neg.s $f1, $f0\n");
  	fprintf(ft,"   s.s $f1, 0($sp)\n");
}

// addition des 2 variables float en sommet de pile
void AddFloat(void)
{
	fprintf(ft,"  #AddFloat\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   l.s $f1, 4($sp)\n");
	fprintf(ft,"   add.s $f2, $f1, $f0\n");
	fprintf(ft,"   s.s $f2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// soustraction des 2 variables float en sommet de pile
// $f1 - $f0  ;  2em pile - sommet pile
void SubFloat(void)
{
	fprintf(ft,"  #SubFloat\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   l.s $f1, 4($sp)\n");
	fprintf(ft,"   sub.s $f2, $f1, $f0\n");
	fprintf(ft,"   s.s $f2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// multiplication des 2 variables float en sommet de pile
void MulFloat(void)
{
	fprintf(ft,"  #MulFloat\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   l.s $f1, 4($sp)\n");
	fprintf(ft,"   mul.s $f2, $f1, $f0\n");
	fprintf(ft,"   s.s $f2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// division des 2 variables float en sommet de pile
// $f1 / $f0  ;  2em pile /0 sommet pile
void DivFloat(void)
{
	fprintf(ft,"  #DivFloat\n");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	fprintf(ft,"   l.s $f1, 4($sp)\n");
	fprintf(ft,"   div.s $f2, $f1, $f0\n");
	fprintf(ft,"   s.s $f2, 4($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

////////////////////////////////////////////////////////
// Block
////////////////////////////////////////////////////////

// creer un bloc
void CreateBlock()
{
	fprintf(ft,"  #CreateBloc\n");
	
	offset_tmp=offset;
	offset=0;
}

// ajouter une variable "name" locale a un block
void AddVarBlock(char* name, int reservation)
{
	int size=0;
	Bornes* bornes;

	dicSelect(name);

  if(dicGetOffset() != -1)
  {
    fprintf(ft,"  #AddVarBlock_%s\n", name);
	
    //reservation pour argument
    if((dicGetClass()==CLASS_VARIABLE || dicGetClass()==CLASS_ARRAY) 
                                         && reservation == 1)
    {
      size+=4;
      //reserve l'espace
      fprintf(ft,"   addiu $sp, $sp, %d\n", -size);
  
    }
    
    //variable simple
    if(dicGetClass()==CLASS_VARIABLE && reservation == 0)
    {
      size+=4;
      //reserve l'espace
      fprintf(ft,"   addiu $sp, $sp, %d\n", -size);
      
      //init a 0
      fprintf(ft,"   li $t0, 0\n" );
      fprintf(ft,"   sw $t0, 0($sp)\n");
    }
    
    //tableau
    else if(dicGetClass()==CLASS_ARRAY && reservation == 0)
    {
      bornes=dicGetArray();
      assert(bornes != NULL);
      //adresse
      size+=4;
      //bornes
      size+=8;
      //cases
      size+=(1+bornes->BorneSup-bornes->BorneInf)*4;
      
	  //reserve l'espace
      fprintf(ft,"   addiu $sp, $sp, %d\n", -size);
      fprintf(ft,"   move $t0, $sp\n");
      fprintf(ft,"   addi $t0, 12\n");
      fprintf(ft,"   sw $t0, 0($sp)\n");
      fprintf(ft,"   li $t0, %d\n",bornes->BorneInf);
      fprintf(ft,"   sw $t0, 4($sp)\n");
      fprintf(ft,"   li $t0, %d\n",bornes->BorneSup);
      fprintf(ft,"   sw $t0, 8($sp)\n");
        
    }
    
    offset=offset-size;
    //MAJ table de symbole
    dicSetOffset(offset);
  
    //init a 0 des tableaux non arguments
    if(dicGetClass()==CLASS_ARRAY && reservation == 0)
    {
      fprintf(ft,"   li $t0, 0\n" );
      size = size -4;
      while(size >= 12)
      {
        fprintf(ft,"   sw $t0, %d($sp)\n", size);
        size = size -4;
      }
    }
  }
  else
  {
    fprintf(ft,"  #AddVarBlock_Global_%s\n", name);
    if(dicGetClass()==CLASS_VARIABLE)
    {
      switch(dicGetType())
      {
        case SYM_BOOLEAN:
          AddStaticBoolData(name);
          break;
        case SYM_REAL:
          AddStaticFloatData(name);
          break;
        case SYM_INTEGER:
          AddStaticIntData(name);
          break;
      }
    }
    else
    {  
      AddStaticArrayData(name);
    }
  }
}

// clore un block (liberer la place)
void EndBlock()
{
	int exist;
	int size=0;

	Bornes* bornes;

	fprintf(ft,"  #EndBlock\n");
	
	exist=dicSelectFirst();
	while(exist)
	{
		//variable simple
		if(dicGetClass()==CLASS_VARIABLE && dicGetOffset() != -1)
		{
			size+=4;			
		}
		//tableau
		else if(dicGetClass()==CLASS_ARRAY && dicGetOffset() != -1)
		{
			bornes=dicGetArray();
      if(bornes != NULL) //tableau local
      {
        size+=4;
        //bornes
        size+=8;
        //cases
        size+=(1+bornes->BorneSup-bornes->BorneInf)*4;
      }
      else //argument: qu'une case
      {
        size+=4;
      }
		}
		//met a jour le deplacement (dictionnaire)
		exist=dicSelectNext();
	}
	//libere l'espace
	fprintf(ft,"   addiu $sp, $sp, %d\n", size);

}

////////////////////////////////////////////////////////
// Procedure
////////////////////////////////////////////////////////

// creer le label d'une procedure
void CreateProc(char * name)
{
	int id;

	dicSelect(name);

	fprintf(ft,"  #CreateProc_%s\n", name);
	
	//on est dans le "main", le code qui suit ne doit etre execute qu'en cas d'appel...
	fprintf(ft,"   b end_%s_%d\n", name, dicGetId());
	
	id=dicGetId();
	fprintf(ft,"%s_%d:\n", name, id);	
}

// appel d'une procedure
void CallProc(char * name)
{
	dicSelect(name);

	fprintf(ft,"  #CallProc_%s\n", name);
	
	//alloue la place pour le resultat (si necessaire)
	if(dicGetType()!=SYM_VOID)
	{
		fprintf(ft,"   addiu $sp, $sp, -4\n");
		offset=offset-4;
	}
	
	dicSetOffset(offset);
	
	//on sauve $ra
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   sw $ra, 0($sp)\n");
	
	//on sauve $s0
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   sw $s0, 0($sp)\n");
	//on sauve $fp
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   sw $fp, 0($sp)\n");
	
}

// fin d'appel d'une procedure
void EndCallProc(char * name)
{
	int nb_arg;
	
	fprintf(ft,"  #EndCallProc_%s\n", name);
	
		
	fprintf(ft,"   move $fp, $sp\n");
	
	//deplacement pour se mettre au debut des arg 
	nb_arg=dicGetArgsQuantity();
	fprintf(ft,"   addiu $fp, $fp, %d\n",4*nb_arg);
	
	//dans la proc on va realouer les arg qui sont DEJA sur la pile
	fprintf(ft,"   move $sp, $fp\n");
	
	//on saute a l'@ de la procedure
	dicSelect(name);
	fprintf(ft,"   jal %s_%d\n", name, dicGetId());
	
	//on recupere $ra
	fprintf(ft,"   lw $ra, 0($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;

}

// retour d'une procedure
void ReturnProc(char * name)
{
	int id;
	
	dicSelect(name);

	fprintf(ft,"  #ReturnProc_%s\n", name);
	
	//on recupere $fp
	fprintf(ft,"   lw $fp, 0($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
	//on recupere $s0
	fprintf(ft,"   lw $s0, 0($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
	
	//retour a l'appelant
	fprintf(ft,"   jr $ra\n");
	
	
	id=dicGetId();
	fprintf(ft,"end_%s_%d:\n", name, id);
	
	offset=offset_tmp;
}


////////////////////////////////////////////////////////
// Pile
////////////////////////////////////////////////////////

// Reference d'une variable en sommet de pile
void SetReferenceStack(char * name)
{
	dicSelect(name);
	
	fprintf(ft,"  #SetReferenceStack_%s\n", name);
	
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   li $t0, %d\n", dicGetOffset());
	fprintf(ft,"   add $t0, $t0, $fp\n", dicGetOffset());
	fprintf(ft,"   sw $t0, 0($sp)\n");
}

// Libere la place du sommet de pile
void FreeStack(void)
{
	fprintf(ft,"  #FreeStack\n");
	
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
}

// met une constante entiere sur la pile
void SetConstIntStack(int i)
{
	fprintf(ft,"  #SetConstIntStack_%d\n", i);
	
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   li $t0, %d\n", i);
	fprintf(ft,"   sw $t0, 0($sp)\n");	
}

// met une constante booleene sur la pile
void SetConstBoolStack(int i)
{
	fprintf(ft,"  #SetConstBoolStack_%d\n", i);
	
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   li $t0, %d\n", i);
	fprintf(ft,"   sw $t0, 0($sp)\n");	
}

//  met une constante flotante en sommet de pile
void SetConstFloatStack(float i)
{
	fprintf(ft,"  #SetConstFloatStack_%d\n", i);
	
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
	fprintf(ft,"   li.s $f0, %f\n", i);
	fprintf(ft,"   s.s $f0, 0($sp)\n");	
}

void SetTabHeadStack(char *name)
{
  DICContext tmp=dicGetContext();

  fprintf(ft,"  #SetTabHeadStack_%s\n", name);

	//var dans le contexte local
  if(dicSelect(name))
	{
      assert(dicGetClass() == CLASS_ARRAY);
			//pas static 
			if(dicGetOffset()!=-1)
			{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
			}
			// static
			else
			{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t1, 0($t0)\n");
				
			}
      fprintf(ft,"   sw $t0, 0($sp)\n");
	}
	
	//global
	else
	{
		dicSetContext(DIC_GLOBAL);
		dicSelect(name);
		assert(dicGetClass() == CLASS_ARRAY);

			//on sauve $fp au dessu du sommet de pile (invisible)
			fprintf(ft,"   sw $fp, -8($sp)\n");
			//on recupere le $fp global (@ debut code, dans $s0)
			fprintf(ft,"   move $fp, $s0\n");
    
			fprintf(ft,"   addiu $sp, $sp, -4\n");
			offset=offset-4;
			fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
			fprintf(ft,"   sw $t0, 0($sp)\n");
      
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
		
	}
  
	dicSetContext(tmp);
}

// met une var sur la pile (pour affectation, exp arith,...)
void SetStack(char* name)
{
	DICContext tmp=dicGetContext();
	
	fprintf(ft,"  #SetStack_%s\n", name);

	//var dans le contexte local

	if(dicSelect(name))
	{
		if(dicGetType()==SYM_REAL)
		{	
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   l.s $f0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   s.s $f0, 0($sp)\n");
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   l.s $f0, 0($t0)\n");
					fprintf(ft,"   s.s $f0, 0($sp)\n");
				}
			}
			// static
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   l.s $f0, 0($t0)\n");
					fprintf(ft,"   s.s $f0, 0($sp)\n");		
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t1, 0($t0)\n");
					fprintf(ft,"   l.s $f0, 0($t1)\n");
					fprintf(ft,"   s.s $f0, 0($sp)\n");
				}
			}
		}
		else
		{		
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   sw $t0, 0($sp)\n");
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   lw $t1, 0($t0)\n");
					fprintf(ft,"   sw $t1, 0($sp)\n");
				}
			}
			// static
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t0, 0($t1)\n");
					fprintf(ft,"   sw $t0, 0($sp)\n");		
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t1, 0($t0)\n");
					fprintf(ft,"   lw $t2, 0($t1)\n");
					fprintf(ft,"   sw $t2, 0($sp)\n");
				}
			}
		}
	}
	//global
	else
	{
		dicSetContext(DIC_GLOBAL);
		dicSelect(name);
		
		if(dicGetClass()==CLASS_PROCEDURE)
		{
			//IMPOSIBLE : appel de proc => res en sommet de pile...
		}
		else
		{
			//on sauve $fp au dessu du sommet de pile (invisible)
			fprintf(ft,"   sw $fp, -8($sp)\n");
			//on recupere le $fp global (@ debut code, dans $s0)
			fprintf(ft,"   move $fp, $s0\n");
			
			if(dicGetType()==SYM_REAL)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   l.s $f0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   s.s $f0, 0($sp)\n");		
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   l.s $f0, 0($t0)\n");
					fprintf(ft,"   s.s $f0, 0($sp)\n");
				}
			}
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   sw $t0, 0($sp)\n");		
				}
				//par reference
				else
				{
					fprintf(ft,"   addiu $sp, $sp, -4\n");
					offset=offset-4;
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   lw $t1, 0($t0)\n");
					fprintf(ft,"   sw $t1, 0($sp)\n");
				}
			}
		}

		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
		
	}

	dicSetContext(tmp);
}

// affectation
void GetStack(char* name)
{
	DICContext tmp=dicGetContext();
	
	fprintf(ft,"  #GetStack_%s\n", name);
		
	//var dans le contexte local
	if(dicSelect(name))
	{
		if(dicGetType()==SYM_REAL)
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   s.s $f0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   s.s $f0, 0($t0)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
			// static
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   s.s $f0, 0($t0)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   la $t0, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t1, 0($t0)\n");
					fprintf(ft,"   s.s $f0, 0($t1)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
		}
		else
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   sw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   lw $t1, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   sw $t0, 0($t1)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
			// static
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
					fprintf(ft,"   sw $t0, 0($t1)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   la $t1, %s_%d\n", name, dicGetId());
					fprintf(ft,"   lw $t2, 0($t1)\n");
					fprintf(ft,"   sw $t0, 0($t2)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
		}			
	}
	//global
	else
	{
		dicSetContext(DIC_GLOBAL);
		dicSelect(name);

		if(dicGetClass()==CLASS_PROCEDURE)
		{
			fprintf(ft,"   lw $t0, 0($sp)\n");
			fprintf(ft,"   sw $t0, 12($fp)\n");
			fprintf(ft,"   addiu $sp, $sp, 4\n");
		}
		else
		{
			//on sauve $fp au dessu du sommet de pile (invisible)
			fprintf(ft,"   sw $fp, -4($sp)\n");
			//on recupere le $fp global (@ debut code, dans $s0)
			fprintf(ft,"   move $fp, $s0\n");
		
		
			if(dicGetType()==SYM_REAL)
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   s.s $f0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   l.s $f0, 0($sp)\n");
					fprintf(ft,"   lw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   s.s $f0, 0($t0)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
			else
			{
				//par valeur
				if(dicGetRef()==ARG_VALUE)
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   sw $t0, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
					
				}
				//par reference
				else
				{
					fprintf(ft,"   lw $t0, 0($sp)\n");
					fprintf(ft,"   lw $t1, %d($fp)\n", dicGetOffset());
					fprintf(ft,"   sw $t0, 0($t1)\n");
					fprintf(ft,"   addiu $sp, $sp, 4\n");
					offset=offset+4;
				}
			}
      //on restaure $fp local
      fprintf(ft,"   lw $fp, -8($sp)\n");
		}
	}
	dicSetContext(tmp);
}

//prend la valeur de la case t[i] et la met sur la pile (sommet)
//(a l'endroit ou se trouvait i)
void GetArrayValueStack(char* name)
{
	DICContext tmp=dicGetContext();

	Bornes* bornes;
	
	fprintf(ft,"  #GetArrayValueStack_%s\n", name);

	// recuper l'id de la case sur la pile
	fprintf(ft,"   lw $t0, 0($sp)\n");

		
	 //var dans le contexte local
	if(dicSelect(name))
	{
		//borne inf du tableau
		bornes=dicGetArray();
		
		if(dicGetType()==SYM_REAL)
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//@ debut tableau (data)
				fprintf(ft,"   move $t5, $fp\n");
				fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
				fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation
				fprintf(ft,"   l.s $f3, 0($t0)\n");
				//on le met a la place de l'id en sommet de pile
				fprintf(ft,"   s.s $f3, 0($sp)\n");				
			}
			// static
			else
			{
				//@ debut tableau (borne inf)
				fprintf(ft,"   la $t5, %s_%d\n", name, dicGetId());
				fprintf(ft,"   addi $t5, $t5, 12\n");
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation
				fprintf(ft,"   l.s $f2, 0($t0)\n");
				//on le met a la place de l'id en sommet de pile
				fprintf(ft,"   s.s $f2, 0($sp)\n");
			}
		}
		else
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//@ debut tableau (data)
				fprintf(ft,"   move $t5, $fp\n");
				fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
				fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation
				fprintf(ft,"   lw $t3, 0($t0)\n");
				//on le met a la place de l'id en sommet de pile
				fprintf(ft,"   sw $t3, 0($sp)\n");
			}
			// static
			else
			{
				//@ debut tableau (borne inf)
				fprintf(ft,"   la $t5, %s_%d\n", name, dicGetId());
				fprintf(ft,"   addi $t5, $t5, 12\n");
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation
				fprintf(ft,"   lw $t2, 0($t0)\n");
				//on le met a la place de l'id en sommet de pile
				fprintf(ft,"   sw $t2, 0($sp)\n");
			}
		}
	}
	//global
	else
	{
		dicSetContext(DIC_GLOBAL);
		dicSelect(name);
		
		
		//on sauve $fp au dessu du sommet de pile (invisible)
		fprintf(ft,"   sw $fp, -4($sp)\n");
		//on recupere le $fp global (@ debut code, dans $s0)
		fprintf(ft,"   move $fp, $s0\n");
		
		//borne inf du tableau
		bornes=dicGetArray();

		if(dicGetType()==SYM_REAL)
		{
			//@ debut tableau (data)
			fprintf(ft,"   move $t5, $fp\n");
			fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
			fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
			//deplacement
			fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
			fprintf(ft,"   sub $t0, $t0, $t6\n");
			fprintf(ft,"   li $t1, 4\n");
			fprintf(ft,"   mul $t0, $t0, $t1\n");
			//case
			fprintf(ft,"   add $t0, $t0, $t5\n");
			//recuperation
			fprintf(ft,"   l.s $f3, 0($t0)\n");
			//on le met a la place de l'id en sommet de pile
			fprintf(ft,"   s.s $f3, 0($sp)\n");
		}
		else
		{
			//@ debut tableau (data)
			fprintf(ft,"   move $t5, $fp\n");
			fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
			fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
			//deplacement
			fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
			fprintf(ft,"   sub $t0, $t0, $t6\n");
			fprintf(ft,"   li $t1, 4\n");
			fprintf(ft,"   mul $t0, $t0, $t1\n");
			//case
			fprintf(ft,"   add $t0, $t0, $t5\n");
			//recuperation
			fprintf(ft,"   lw $t3, 0($t0)\n");
			//on le met a la place de l'id en sommet de pile
			fprintf(ft,"   sw $t3, 0($sp)\n");
		}
		
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
	}
	
	dicSetContext(tmp);
}

//sommet pile => valeur ; 2eme de pile => i
//prend la valeur sur la pile (sommet) et la met dans la case t[i]
void SetArrayValueStack(char* name)
{
	DICContext tmp=dicGetContext();

	Bornes* bornes;
	
	fprintf(ft,"  #SetArrayValueStack_%s\n", name);

	// recuper l'id de la case sur la pile
	fprintf(ft,"   lw $t0, 4($sp)\n");

	
		
	//var dans le contexte local
	if(dicSelect(name))
	{
		//borne inf du tableau
		bornes=dicGetArray();
		
		if(dicGetType()==SYM_REAL)
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//@ debut tableau (data)
				fprintf(ft,"   move $t5, $fp\n");
				fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
				fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation en sommet de pile
				fprintf(ft,"   l.s $f3, 0($sp)\n");
				//on le met dans la case
				fprintf(ft,"   s.s $f3, 0($t0)\n");
			}
			// static
			else
			{
				//@ debut tableau (borne inf)
				fprintf(ft,"   la $t5, %s_%d\n", name, dicGetId());
				fprintf(ft,"   addi $t5, $t5, 12\n");
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation en sommet de pile
				fprintf(ft,"   l.s $f3, 0($sp)\n");
				//on le met dans la case
				fprintf(ft,"   s.s $f3, 0($t0)\n");
			}
		}
		else
		{
			//pas static 
			if(dicGetOffset()!=-1)
			{
				//@ debut tableau (data)
				fprintf(ft,"   move $t5, $fp\n");
				fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
				fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation en sommet de pile
				fprintf(ft,"   lw $t3, 0($sp)\n");
				//on le met dans la case
				fprintf(ft,"   sw $t3, 0($t0)\n");
			}
			// static
			else
			{
				//@ debut tableau (borne inf)
				fprintf(ft,"   la $t5, %s_%d\n", name, dicGetId());
				fprintf(ft,"   addi $t5, $t5, 12\n");
				//deplacement
				fprintf(ft,"   lw $t6, -8($t5)\n");
				fprintf(ft,"   sub $t0, $t0, $t6\n");
				fprintf(ft,"   li $t1, 4\n");
				fprintf(ft,"   mul $t0, $t0, $t1\n");
				//case
				fprintf(ft,"   add $t0, $t0, $t5\n");
				//recuperation en sommet de pile
				fprintf(ft,"   lw $t3, 0($sp)\n");
				//on le met dans la case
				fprintf(ft,"   sw $t3, 0($t0)\n");
			}
		}
	}
	//global
	else
	{
		dicSetContext(DIC_GLOBAL);
		
		dicSelect(name);
		//borne inf du tableau
		bornes=dicGetArray();

		
		//on sauve $fp au dessu du sommet de pile (invisible)
		fprintf(ft,"   sw $fp, -4($sp)\n");
		//on recupere le $fp global (@ debut code, dans $s0)
		fprintf(ft,"   move $fp, $s0\n");
		

		if(dicGetType()==SYM_REAL)
		{
			//@ debut tableau (data)
			fprintf(ft,"   move $t5, $fp\n");
			fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
			fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
			//deplacement
			fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
			fprintf(ft,"   sub $t0, $t0, $t6\n");
			fprintf(ft,"   li $t1, 4\n");
			fprintf(ft,"   mul $t0, $t0, $t1\n");
			//case
			fprintf(ft,"   add $t0, $t0, $t5\n");
			//recuperation en sommet de pile
			fprintf(ft,"   l.s $f3, 0($sp)\n");
			//on le met dans la case
			fprintf(ft,"   s.s $f3, 0($t0)\n");
		}
		else
		{
			//@ debut tableau (data)
			fprintf(ft,"   move $t5, $fp\n");
			fprintf(ft,"   addi $t5, $t5, %d\n", dicGetOffset());
			fprintf(ft,"   lw $t5, 0($t5)\n");//@debut data
			//deplacement
			fprintf(ft,"   lw $t6, -8($t5)\n");//borne inf
			fprintf(ft,"   sub $t0, $t0, $t6\n");
			fprintf(ft,"   li $t1, 4\n");
			fprintf(ft,"   mul $t0, $t0, $t1\n");
			//case
			fprintf(ft,"   add $t0, $t0, $t5\n");
			//recuperation en sommet de pile
			fprintf(ft,"   l.s $f3, 0($sp)\n");
			//on le met dans la case
			fprintf(ft,"   s.s $f3, 0($t0)\n");
		}
		
		//on restaure $fp local
		fprintf(ft,"   lw $fp, -4($sp)\n");
	}
	dicSetContext(tmp);
	
	fprintf(ft,"   addiu $sp, $sp, 8\n");
	offset=offset+8;
}


////////////////////////////////////////////////////////
// If
////////////////////////////////////////////////////////

// creer le label d'un if et met a jour les compteurs
void If()
{
	BoucleAddEntry();
	fprintf(ft,"  #If_%d\n", CurBoucle->id);
	fprintf(ft,"if_%d:\n", CurBoucle->id);
}

// teste si la condition est vrai
void Then()
{
	//prend le resultat de la condition et libere la place
	fprintf(ft,"   lw $t0, 0($sp)\n");
	fprintf(ft,"   addiu $sp, $sp, 4\n");
	offset=offset+4;
	//then
	fprintf(ft,"   li $t1, 1\n");
	fprintf(ft,"   beq $t0, $t1, then_%d\n", CurBoucle->id);
	//else
	fprintf(ft,"   li $t1, 0\n");
	fprintf(ft,"   beq $t0, $t1, else_%d\n", CurBoucle->id);

	fprintf(ft,"then_%d:\n", CurBoucle->id);
}

// fin the debut else
void EndThen()
{
	fprintf(ft,"   j endif_%d\n", CurBoucle->id);
	fprintf(ft,"else_%d:\n", CurBoucle->id);
}

// else
void Else()
{}

// else
void EndElse()
{
}

// label fin if et mise a jour des compteurs
void EndIf()
{	
	fprintf(ft,"  #EndIf_%d\n", CurBoucle->id);
	fprintf(ft,"endif_%d:\n", CurBoucle->id);

	BoucleCleanEntry();
}

////////////////////////////////////////////////////////
// While
////////////////////////////////////////////////////////

// creer le label d'un while et met a jour les compteurs
void While()
{
	BoucleAddEntry();
	fprintf(ft,"  #While_%d\n", CurBoucle->id);

  //compatibilite avec les for, reserve +2 mots
  fprintf(ft,"   addiu $sp, $sp, -8\n"); 
  
  //label forloop_%d pour compatibilite avec les For
  fprintf(ft,"forloop_%d:\n", CurBoucle->id);
  
  //compatibilite avec les for, 2 mots en arriere
  //le premier sera le resultat de la condition
  //l'autre est vide
	fprintf(ft,"   addiu $sp, $sp, 8\n");
  
}

// teste si la condition est vrai
void WhileDo()
{
  fprintf(ft,"  #WhileDo_%d\n", CurBoucle->id);
	//prend le resultat de la condition -> $t0
	fprintf(ft,"   lw $t0, 0($sp)\n");
  
  //compatibilite avec les for, 1 mot en avant
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
  
  //condition a 0, on saute a la fin
  fprintf(ft,"   li $t1, 0\n");
	fprintf(ft,"   beq $t0, $t1, endfor_%d\n", CurBoucle->id);
  
	fprintf(ft,"whileDo_%d:\n", CurBoucle->id);
}

// label endwhile et mise a jour des compteurs
void EndWhile()
{
	fprintf(ft,"  #EndWhile_%d\n", CurBoucle->id);
	fprintf(ft,"   b while_%d\n", CurBoucle->id);
	fprintf(ft,"endwhile_%d:\n", CurBoucle->id);

	BoucleCleanEntry();
}

////////////////////////////////////////////////////////
// For
////////////////////////////////////////////////////////

// creer le label d'un for et met a jour les compteurs
void For()
{
	BoucleAddEntry();
	fprintf(ft,"  #For_%d\n", CurBoucle->id);
	fprintf(ft,"for_%d:\n", CurBoucle->id);
}

void VarFor()
{
	fprintf(ft,"  #VarFor_%d\n", CurBoucle->id);
	fprintf(ft,"   addiu $sp, $sp, -4\n");
	offset=offset-4;
}


void ForDo(char* name)
{
	fprintf(ft,"   b fordo2_%d\n", CurBoucle->id);
	
	fprintf(ft,"forloop_%d:\n", CurBoucle->id);
	fprintf(ft,"   addiu $sp, $sp, 12\n");
	offset=offset+12;
	SetStack(name);
	fprintf(ft,"   addiu $sp, $sp, -8\n");
	offset=offset-8;
	
	fprintf(ft,"   lw $t0, 8($sp)\n");
	fprintf(ft,"   lw $t2, 4($sp)\n");
	fprintf(ft,"   add $t0, $t0, $t2\n");
	fprintf(ft,"   sw $t0, 8($sp)\n");
	
	fprintf(ft,"   addiu $sp, $sp, 8\n");
	offset=offset+8;
	GetStack(name);
	fprintf(ft,"   addiu $sp, $sp, -12\n");
	offset=offset-12;
	
	fprintf(ft,"fordo2_%d:\n", CurBoucle->id);
	
	fprintf(ft,"   lw $t0, 8($sp)\n");
	fprintf(ft,"   lw $t1, 0($sp)\n");
	
	fprintf(ft,"   bgt $t0, $t1, endfor_%d\n", CurBoucle->id);
}

// label endfor et mise a jour des compteurs
void EndFor()
{
	fprintf(ft,"  #EndFor_%d\n", CurBoucle->id);
	
	fprintf(ft,"   b forloop_%d\n", CurBoucle->id);
  
	fprintf(ft,"endfor_%d:\n", CurBoucle->id);
	fprintf(ft,"   addiu $sp, $sp, 12\n"); //recuperation de la place du for
	offset=offset+12;

	BoucleCleanEntry();
}

////////////////////////////////////////////////////////
// Main
////////////////////////////////////////////////////////

/*int main()
{
	CreateFileText("text.s");
	CreateFileData("data.s");
*/
/*
	If();
	Then();
		If();
		Then();
		EndThen();
		Else();
		EndElse();
		EndIf();

		For();
		ForDo();
		EndFor();
	EndThen();
	Else();
		While();
		WhileDo();
			While();
			WhileDo();
			EndWhile();
		EndWhile();

		While();
		WhileDo();
		EndWhile();
*/		
/*	
	If();
	SetConstIntStack(1);
	Then();
	DisplayFloat(3.5);
	EndThen();
	Else();
	EndElse();
	EndIf();
*/	
	//EndElse();
	//EndIf();

/*
	dicAddEntry("a");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("a");	
	SetConstIntStack(9);
	GetStack("a");//a=9
	
	dicAddEntry("b");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de b
	AddVarBlock("b");	
	SetConstIntStack(27);
	GetStack("b");//b=9
	
	
	//addition
	SetStack("b");
	SetStack("a");
	AddInt();
	fprintf(ft,"   lw $t6, 0($sp)\n");
	FreeStack();
	
	//division
	SetStack("b");
	SetStack("a");
	DivInt();
	fprintf(ft,"   lw $t6, 0($sp)\n");
	FreeStack();
	
	EndBlock();
*/
/*	
	SetConstIntStack(5);
	SetConstIntStack(2);
	DivInt();
	fprintf(ft,"   lw $t6, 0($sp)\n");
	FreeStack();
*/	
	
//	DisplayString("\"toto\"");
/*	
	dicAddEntry("a");
	dicSetType(SYM_REAL);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("a");	
	SetConstFloatStack(2.5);
	GetStack("a");//a=2.5
	
	dicAddEntry("b");
	dicSetType(SYM_REAL);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de b
	AddVarBlock("b");	
	SetConstFloatStack(5.5);
	GetStack("b");//b=5.5
	
	SetConstFloatStack(5.5);
	SetConstFloatStack(2.5);
	SubFloat();
	fprintf(ft,"   l.s $f4, 0($sp)\n");
	FreeStack();
	
	//addition
	SetStack("b");
	SetStack("a");
	DivFloat();
	fprintf(ft,"   l.s $f5, 0($sp)\n");
	FreeStack();
	
	//division
	SetStack("b");
	SetStack("a");
	DivFloat();
	fprintf(ft,"   l.s $f6, 0($sp)\n");
	FreeStack();
	
	//multiplication
	SetStack("b");
	SetStack("a");
	MulFloat();
	fprintf(ft,"   l.s $f7, 0($sp)\n");
	FreeStack();
	
	EndBlock();
*/	
/*	
	dicAddEntry("a");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("a");	
	
	For();
	SetConstIntStack(2);
	GetStack("a");
	VarFor("a");
	SetConstIntStack(1);
	SetConstIntStack(10);
	ForDo("a");
		DisplayString("\"toto\\n\"");
		SetConstIntStack(11);
		GetStack("a");
	EndFor("a");
	
	FreeStack();
	*/
		
	/*
	dicSetBuilderClass(CLASS_ARRAY);
	dicSetBuilderType(SYM_REAL);
	dicAddEntry("t");
	dicSetArray(0,5);
	
	AddVarBlock("t");
	
	SetConstIntStack(0);
	SetConstFloatStack(10.5);
	SetArrayValueStack("t");
	
	
	SetConstIntStack(1);
	SetConstFloatStack(11.5);
	SetArrayValueStack("t");
	
	SetConstIntStack(1);
	GetArrayValueStack("t");
	
	fprintf(ft,"   l.s $f0, 0($sp)\n");
	FreeStack();

	EndBlock();
	CloseFileData();
	CloseFileText();*/
/*
	dicAddEntry("a");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("a");
	
	SetConstIntStack(10);
	GetStack("a");//a=10
	
	While();
	SetConstIntStack(1);
	SetStack("a");
	LessThan();
	WhileDo();
		//a=a-1;
		SetStack("a");
		SetConstIntStack(1);
		SubInt();
		GetStack("a");
	DisplayString("\"toto\"");
	EndWhile();
*/
/*	dicAddEntry("a");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("a");
	
	dicAddEntry("b");
	dicSetType(SYM_INTEGER);
	dicSetClass(CLASS_VARIABLE);
	dicSetRef(ARG_VALUE);
	//declaration de a
	AddVarBlock("b");
	
	SetConstIntStack(10);
	GetStack("a");//a=10
	
	DisplayVarInt("a");
	
	SetStack("a");
	GetStack("b");//a=10
	
	DisplayVarInt("b");
	
	FreeStack();
	
	return 0;*/
//}


